"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Command = require('commander').Command;
var command_manager_1 = require("./command-manager");
var static_variable_1 = require("../constants/static-variable");
function create(command, customerCommandName, description) {
    var params = [];
    var _command = new Command(command);
    var processArgv = [];
    var start = false;
    for (var i = 0; i < process.argv.length; i++) {
        if (!start) {
            processArgv.push(process.argv[i]);
        }
        else {
            params.push(process.argv[i]);
        }
        if (process.argv[i] === command) {
            start = true;
        }
    }
    if (params.length !== 0) {
        process.env.temp_params = params.join(' ');
    }
    else {
        params = process.env.temp_params ? process.env.temp_params.split(' ') : [];
    }
    process.argv = processArgv;
    _command
        .description(description || '')
        .action(function () {
        var template = process['env'][static_variable_1.PROCESS_ENV_TEMPLATE_NAME];
        if (template) {
            var commandManager = new command_manager_1.default(template, command, customerCommandName, params.join(' '));
            commandManager.init();
        }
    });
    return _command;
}
exports.default = create;
//# sourceMappingURL=index.js.map