"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentExeCute = exports.generateSynchronizeComponentExeList = exports.synchronizeExecuteComponentList = void 0;
var fs = require('fs');
var path = require('path');
var os = require('os');
var util = require('util');
var inquirer = require('inquirer');
var exec = util.promisify(require('child_process').exec);
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
var axios_1 = require("axios");
var i18n_1 = require("../utils/i18n");
var download_manager_1 = require("../utils/download-manager");
var get_manager_1 = require("../config/get/get-manager");
var add_manager_1 = require("../config/add/add-manager");
var logger = require("../utils/logger");
var package_type_1 = require("../utils/package-type");
var hook_1 = require("./hook");
var config_error_1 = require("../error/config-error");
var static_variable_1 = require("../constants/static-variable");
var S_COMPONENT_BASE_PATH = path.join(os.homedir(), ".s/components");
var TYPE_MAP = (_a = {},
    _a[package_type_1.PackageType.component] = 'Component',
    _a[package_type_1.PackageType.plugin] = 'Plugin',
    _a[package_type_1.PackageType.application] = 'Application',
    _a);
function synchronizeExecuteComponentList(list, index, initData) {
    if (list === void 0) { list = []; }
    if (index === void 0) { index = 0; }
    if (initData === void 0) { initData = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(index >= 0 && index < list.length)) return [3 /*break*/, 2];
                    return [4 /*yield*/, list[index]().then(function (_a) {
                            var name = _a.name, data = _a.data;
                            return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            initData[name] = data;
                                            return [4 /*yield*/, synchronizeExecuteComponentList(list, index + 1, initData)];
                                        case 1: return [2 /*return*/, _b.sent()];
                                    }
                                });
                            });
                        })];
                case 1: return [2 /*return*/, _a.sent()];
                case 2: return [2 /*return*/, initData];
            }
        });
    });
}
exports.synchronizeExecuteComponentList = synchronizeExecuteComponentList;
function generateSynchronizeComponentExeList(_a, equipment) {
    var _this = this;
    var list = _a.list, parse = _a.parse, parsedObj = _a.parsedObj, method = _a.method, params = _a.params;
    return list.map(function (projectName) {
        return function () {
            return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                var projectConfig, componentExecute, Output, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 3, , 4]);
                            parsedObj.Params = params || '';
                            logger.info(i18n_1.default.__("Start executing project {{projectName}}", { projectName: projectName }));
                            return [4 /*yield*/, equipment(parse, projectName, parsedObj)];
                        case 1:
                            projectConfig = _a.sent();
                            componentExecute = new ComponentExeCute(projectConfig, method);
                            return [4 /*yield*/, componentExecute.init()];
                        case 2:
                            Output = _a.sent();
                            parsedObj[projectName].Output = Output;
                            logger.info(i18n_1.default.__("Project {{projectName}} successfully to execute \n\t", { projectName: projectName }));
                            resolve({ name: projectName, data: Output });
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            if (String(e_1).indexOf('method does not exist') !== -1) {
                                logger.error(i18n_1.default.__("Project {{projectName}} doesn't have the method: {{method}}", { projectName: projectName, method: method }));
                                resolve({});
                            }
                            else {
                                logger.error(e_1);
                                logger.error(i18n_1.default.__("Project {{projectName}} failed to execute", { projectName: projectName }));
                                resolve({ name: projectName, data: '' });
                            }
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); });
        };
    });
}
exports.generateSynchronizeComponentExeList = generateSynchronizeComponentExeList;
var ComponentExeCute = /** @class */ (function () {
    function ComponentExeCute(componentConfig, method) {
        this.componentConfig = componentConfig;
        this.method = method;
        this.isPackageProject = false;
        if (!fs.existsSync(S_COMPONENT_BASE_PATH)) {
            fs.mkdirSync(S_COMPONENT_BASE_PATH);
        }
        var name = this.componentConfig.Component;
        this.componentPath = path.join(S_COMPONENT_BASE_PATH, "/" + name);
        this.isPackageProject = fs.existsSync(path.join(this.componentPath, '/package.json'));
    }
    ComponentExeCute.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, name, Provider, providerOnlyPrefix, credentials, version, temp, tempPath;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.componentConfig, name = _a.Component, Provider = _a.Provider;
                        providerOnlyPrefix = Provider.split('.')[0];
                        return [4 /*yield*/, this.getCredentials()];
                    case 1:
                        credentials = _b.sent();
                        if (!!credentials) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.setCredentials(providerOnlyPrefix)];
                    case 2:
                        credentials = _b.sent();
                        _b.label = 3;
                    case 3:
                        this.credentials = credentials;
                        // 将密钥缓存到临时环境变量中
                        try {
                            process.env.temp_credentials = JSON.stringify(this.credentials);
                        }
                        catch (e) { }
                        return [4 /*yield*/, fs.existsSync(name)];
                    case 4:
                        if (!_b.sent()) return [3 /*break*/, 5];
                        this.componentPath = name;
                        return [3 /*break*/, 12];
                    case 5:
                        if (!(name.indexOf('@') !== -1)) return [3 /*break*/, 6];
                        temp = name.split('@');
                        name = temp[0];
                        version = temp[1];
                        if (!(name && version)) {
                            throw new Error('Could not get component name and version, please check you component content.');
                        }
                        return [3 /*break*/, 8];
                    case 6: return [4 /*yield*/, this.getRemoteComponentVersion({
                            name: name,
                            provider: providerOnlyPrefix,
                            type: package_type_1.PackageType.component
                        })];
                    case 7:
                        version = _b.sent();
                        _b.label = 8;
                    case 8:
                        tempPath = path.join(S_COMPONENT_BASE_PATH, "/" + name + "-" + providerOnlyPrefix + "@" + version);
                        return [4 /*yield*/, fs.existsSync(tempPath)];
                    case 9:
                        if (!!(_b.sent())) return [3 /*break*/, 11];
                        logger.info(i18n_1.default.__("No component {{name}}-{{provider}}@{{version}} is found, it will be downloaded soon, this may take a few minutes......", { name: name, version: version, provider: providerOnlyPrefix }));
                        return [4 /*yield*/, this.downLoadAndUnCompressComponentV2(package_type_1.PackageType.component, name, providerOnlyPrefix, version)];
                    case 10:
                        _b.sent();
                        _b.label = 11;
                    case 11:
                        this.componentPath = tempPath;
                        _b.label = 12;
                    case 12: return [4 /*yield*/, this.startExecute()];
                    case 13: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    ComponentExeCute.prototype.getCredentials = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, Provider, Access, configUserInput, getManager, providerMap, accessData, result_1, selectObject_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.componentConfig, Provider = _a.Provider, Access = _a.Access;
                        configUserInput = { 'Provider': Provider, 'AliasName': Access };
                        getManager = new get_manager_1.GetManager();
                        return [4 /*yield*/, getManager.initAccessData(configUserInput)];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, getManager.getUserSecretID(configUserInput)];
                    case 2:
                        providerMap = _b.sent();
                        accessData = Provider && Access ? providerMap : providerMap[Provider + "." + (Access || 'default')];
                        if (accessData) {
                            return [2 /*return*/, accessData];
                        }
                        if (!!Access) return [3 /*break*/, 4];
                        // 2020-9-24 循环调用可能出现循环卡死
                        if (process.env['next-command-execute-flag'] === 'true') {
                            try {
                                // 使用现有的缓存密钥
                                return [2 /*return*/, JSON.parse(process.env.temp_credentials || 'error')];
                            }
                            catch (e) {
                                // 抛出错误
                                throw new config_error_1.ConfigError('Calling @serverless-devs/s tools in Extends requires configuring Access in Yaml.');
                            }
                        }
                        logger.warning('\n');
                        logger.warning('  You can configure the specified key in yaml. For example:');
                        logger.warning("\n  " + this.componentConfig.ProjectName);
                        logger.warning("    Component: " + this.componentConfig.Component);
                        logger.warning("    Provider: " + Provider);
                        logger.warning('    Access: Fill in the specified key here');
                        logger.warning('\n');
                        result_1 = '';
                        selectObject_1 = [];
                        Object.keys(providerMap).forEach(function (item) {
                            var temp = {
                                name: item.startsWith('project') ? "" + item.replace('project.', 'project: ') : "" + item.replace(Provider + '.', Provider + ': '),
                                value: item
                            };
                            if (Provider) {
                                if (item.startsWith(Provider) || item.startsWith('project')) {
                                    selectObject_1.push(temp);
                                }
                            }
                            else {
                                selectObject_1.push(temp);
                            }
                        });
                        selectObject_1.push({ name: 'Create a new account', value: 'create' });
                        return [4 /*yield*/, inquirer
                                .prompt([
                                {
                                    type: 'list',
                                    name: 'access',
                                    message: i18n_1.default.__('Please select an access:'),
                                    choices: selectObject_1
                                }
                            ])
                                .then(function (answers) {
                                result_1 = answers.access;
                            })];
                    case 3:
                        _b.sent();
                        if (result_1 === 'create') {
                            return [2 /*return*/, undefined];
                        }
                        return [2 /*return*/, providerMap[result_1]];
                    case 4: 
                    // 没找到密钥信息
                    throw new config_error_1.ConfigError('Failed to get the specified key: {{access}}', {
                        access: Access
                    });
                }
            });
        });
    };
    ComponentExeCute.prototype.setCredentials = function (provider) {
        return __awaiter(this, void 0, void 0, function () {
            var addManager, result, inputProviderAlias;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        addManager = new add_manager_1.AddManager();
                        return [4 /*yield*/, addManager.inputLengthZero(provider)];
                    case 1:
                        result = _a.sent();
                        inputProviderAlias = provider + "." + (addManager.aliasName || 'default');
                        addManager.inputFullData[inputProviderAlias] = result;
                        addManager.writeData(addManager.globalFilePath, addManager.inputFullData);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ComponentExeCute.prototype.componentExist = function () {
        return fs.existsSync(this.componentPath);
    };
    ComponentExeCute.prototype.getRemoteComponentVersion = function (_a) {
        var name = _a.name, provider = _a.provider, type = _a.type;
        return __awaiter(this, void 0, void 0, function () {
            var url, version, result, e_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = static_variable_1.SERVERLESS_CHECK_COMPONENT_VERSION;
                        version = null;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.get(url, {
                                params: {
                                    name: name,
                                    provider: provider,
                                    type: TYPE_MAP[type]
                                }
                            })];
                    case 2:
                        result = _b.sent();
                        if (result.data && result.data.Response && result.data.Response.Version) {
                            version = result.data.Response.Version;
                        }
                        else {
                            throw new Error('Please Check the provider and component');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _b.sent();
                        logger.error(e_2.message);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, version];
                }
            });
        });
    };
    ComponentExeCute.prototype.getLocalComponentVersion = function () {
        var name = this.componentConfig.Component;
        var pkgFile = path.join(S_COMPONENT_BASE_PATH, "/" + name + "/package.json");
        if (!fs.existsSync(pkgFile)) {
            return null;
        }
        var componentPackageJsonObj = require(pkgFile);
        return componentPackageJsonObj.version;
    };
    ComponentExeCute.prototype.preLoadNodeModules = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, stdout, stderr;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(this.isPackageProject &&
                            !fs.existsSync(path.join(this.componentPath, 'node_modules')))) return [3 /*break*/, 2];
                        logger.info('npm install');
                        return [4 /*yield*/, exec('npm install', {
                                cwd: this.componentPath
                            })];
                    case 1:
                        _a = _b.sent(), stdout = _a.stdout, stderr = _a.stderr;
                        if (stderr) {
                            logger.error(stderr);
                        }
                        else {
                            logger.info(stdout);
                        }
                        _b.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.downLoadAndUnCompressComponent = function (type, name, provider) {
        return __awaiter(this, void 0, void 0, function () {
            var downloadManager, componentPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        downloadManager = new download_manager_1.DownloadManager();
                        componentPath = path.join(S_COMPONENT_BASE_PATH, "/" + name);
                        if (!fs.existsSync(componentPath)) {
                            fs.mkdirSync(componentPath);
                        }
                        return [4 /*yield*/, downloadManager.downloadTemplateFromAppCenter(type, name, componentPath, provider)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.downLoadAndUnCompressComponentV2 = function (type, name, provider, version) {
        return __awaiter(this, void 0, void 0, function () {
            var downloadManager, componentPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        downloadManager = new download_manager_1.DownloadManager();
                        componentPath = path.join(S_COMPONENT_BASE_PATH, "/" + name + "-" + provider + "@" + version);
                        if (!fs.existsSync(componentPath)) {
                            fs.mkdirSync(componentPath);
                        }
                        return [4 /*yield*/, downloadManager.downloadTemplateFromAppCenter(type, name, componentPath, provider)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadExtends = function () {
        var _a = this.componentConfig.Extends, Extends = _a === void 0 ? {} : _a;
        var method = this.method;
        var hookExecuteInstance = null;
        var hooks = Extends[method];
        if (hooks) {
            hookExecuteInstance = new hook_1.Hook(hooks);
        }
        return hookExecuteInstance;
    };
    ComponentExeCute.prototype.loadPreExtends = function (extend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!extend) return [3 /*break*/, 2];
                        return [4 /*yield*/, extend.executePreHook()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadAfterExtend = function (extend) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!extend) return [3 /*break*/, 2];
                        return [4 /*yield*/, extend.executeAfterHook()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    ComponentExeCute.prototype.loadComponent = function () {
        return __awaiter(this, void 0, void 0, function () {
            var componentModule;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.preLoadNodeModules()];
                    case 1:
                        _a.sent(); // check and install node_module
                        componentModule = require(this.componentPath);
                        return [2 /*return*/, componentModule];
                }
            });
        });
    };
    ComponentExeCute.prototype.invokeMethod = function (ComponentClass, method, data) {
        return __awaiter(this, void 0, void 0, function () {
            var promise;
            var _this = this;
            return __generator(this, function (_a) {
                promise = new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                    var componentInstance, result, e_3;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                componentInstance = new ComponentClass();
                                return [4 /*yield*/, componentInstance[method](data)];
                            case 1:
                                result = _a.sent();
                                resolve(result);
                                return [3 /*break*/, 3];
                            case 2:
                                e_3 = _a.sent();
                                reject(new Error(e_3.message));
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/, promise];
            });
        });
    };
    ComponentExeCute.prototype.executeCommand = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, Properties, Params, Provider, Access, Component, ProjectName, inputs, ComponentClass, data;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.componentConfig, Properties = _a.Properties, Params = _a.Params, Provider = _a.Provider, Access = _a.Access, Component = _a.Component, ProjectName = _a.ProjectName;
                        inputs = {
                            Properties: Properties,
                            Credentials: this.credentials,
                            Project: {
                                ProjectName: ProjectName,
                                Component: Component,
                                Provider: Provider,
                                AccessAlias: Access || ''
                            },
                            Command: this.method,
                            Args: Params || '',
                            Path: {
                                ConfigPath: process.env.templateFile || ''
                            }
                        };
                        return [4 /*yield*/, this.loadComponent()];
                    case 1:
                        ComponentClass = _b.sent();
                        return [4 /*yield*/, this.invokeMethod(ComponentClass, this.method, inputs)];
                    case 2:
                        data = _b.sent();
                        return [2 /*return*/, data];
                }
            });
        });
    };
    ComponentExeCute.prototype.startExecute = function () {
        return __awaiter(this, void 0, void 0, function () {
            var outData, extend, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        outData = {};
                        if (!(process.env['skip-extends'] === 'true')) return [3 /*break*/, 1];
                        _a = null;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.loadExtends()];
                    case 2:
                        _a = _b.sent();
                        _b.label = 3;
                    case 3:
                        extend = _a;
                        return [4 /*yield*/, this.loadPreExtends(extend)];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, this.executeCommand()];
                    case 5:
                        outData = _b.sent();
                        return [4 /*yield*/, this.loadAfterExtend(extend)];
                    case 6:
                        _b.sent();
                        return [2 /*return*/, outData];
                }
            });
        });
    };
    return ComponentExeCute;
}());
exports.ComponentExeCute = ComponentExeCute;
//# sourceMappingURL=index.js.map