"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var i18n_1 = require("./utils/i18n");
var program = require("commander");
var handler_set_config_1 = require("./utils/handler-set-config");
var logger_1 = require("./utils/logger");
var command_1 = require("./utils/command");
var common_1 = require("./utils/common");
var static_variable_1 = require("./constants/static-variable");
var description = "  _________                               .__\n /   _____/ ______________  __ ___________|  |   ____   ______ ______\n \\_____  \\_/ __ \\_  __ \\  \\/ // __ \\_  __ \\  | _/ __ \\ /  ___//  ___/\n /        \\  ___/|  | \\/\\   /\\  ___/|  | \\/  |_\\  ___/ \\___ \\ \\___ \\\n/_______  /\\___  >__|    \\_/  \\___  >__|  |____/\\___  >____  >____  >\n        \\/     \\/                 \\/                \\/     \\/     \\/\n\n" + i18n_1.default.__('Welcome to the Serverless Devs Tool.') + "\n" + i18n_1.default.__('You can use the corresponding function through the following instructions.') + "\n";
function setSpecialCommand() {
    return __awaiter(this, void 0, void 0, function () {
        var templateFile;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    templateFile = common_1.checkAndReturnTemplateFile();
                    if (!templateFile) return [3 /*break*/, 3];
                    process['env'][static_variable_1.PROCESS_ENV_TEMPLATE_NAME] = templateFile;
                    if (!!['init', 'config', 'platform', 'search', 'set', 'gui'].includes(process.argv[2])) return [3 /*break*/, 3];
                    return [4 /*yield*/, command_1.registerCustomerCommand(program, templateFile)];
                case 1:
                    _a.sent(); // Add user-defined commands
                    return [4 /*yield*/, command_1.regiserUniversalCommand(program, templateFile)];
                case 2:
                    _a.sent(); // Register pan instruction
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function globalParameterProcessing() {
    return __awaiter(this, void 0, void 0, function () {
        var tempGlobal, i;
        return __generator(this, function (_a) {
            tempGlobal = ['skip-extends', 'verbose'];
            for (i = 0; i < tempGlobal.length; i++) {
                process.env[tempGlobal[i]] = 'false';
                if (process.argv.includes('--' + tempGlobal[i])) {
                    process.env[tempGlobal[i]] = 'true';
                    process.argv.splice(process.argv.indexOf('--' + tempGlobal[i]), 1);
                }
            }
            return [2 /*return*/];
        });
    });
}
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var setConfigObject, outputColorFlag, system_command;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, handler_set_config_1.handlerProfileFile({ read: true })];
            case 1:
                setConfigObject = _a.sent();
                outputColorFlag = setConfigObject['output-color'] === false ? false : true;
                // Set output color
                logger_1.default.colorSwitch(outputColorFlag);
                // Wrong instruction
                command_1.registerCommandChecker(program);
                system_command = program
                    .version('', '-v, --version', i18n_1.default.__('Output the version number'))
                    .description(description)
                    .helpOption('-h, --help', i18n_1.default.__('Display help for command'))
                    .command('config', i18n_1.default.__('Configure cloud service account.'))
                    .command('gui', i18n_1.default.__('Start GUI service.'))
                    .command('init', i18n_1.default.__('Initializing a project.'))
                    .command('search', i18n_1.default.__('Search the package.'))
                    .command('platform', i18n_1.default.__('Publish a(an) Component/Plugin/Application.'))
                    .command('set', i18n_1.default.__('Settings for the tool.'))
                    .option('--skip-extends', i18n_1.default.__('Skip the extends section'))
                    .addHelpCommand(false);
                // Global parameter processing
                return [4 /*yield*/, globalParameterProcessing()];
            case 2:
                // Global parameter processing
                _a.sent();
                // Universal instruction processing
                return [4 /*yield*/, setSpecialCommand()];
            case 3:
                // Universal instruction processing
                _a.sent();
                // Verification version
                return [4 /*yield*/, command_1.registerExitOverride(program)];
            case 4:
                // Verification version
                _a.sent();
                try {
                    // Record command
                    command_1.recordCommandHistory(process.argv);
                }
                catch (ex) { }
                system_command.parse(process.argv);
                return [2 /*return*/];
        }
    });
}); })();
//# sourceMappingURL=s.js.map