"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.recordCommandHistory = exports.registerVerbose = exports.regiserUniversalCommand = exports.registerCustomerCommand = exports.registerExitOverride = exports.registerCommandChecker = exports.createCustomerCommand = exports.getCustomerCommandInfo = exports.getParsedTemplateObj = exports.getCommandDetail = void 0;
var commander_1 = require("commander");
var axios_1 = require("axios");
var logger_1 = require("./logger");
var storage = require("./storage");
var check_version_1 = require("./check-version");
var parse_1 = require("./parse");
var fs = require("fs-extra");
var os = require("os");
var command_1 = require("../command");
var BASE_API_URL = 'https://tool.serverlessfans.com';
var COMMAND_DESC_URL = '/api/package/command';
function getCommandDetail(name, provider, version) {
    return __awaiter(this, void 0, void 0, function () {
        var url, command_list, result, command_2, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    url = "" + BASE_API_URL + COMMAND_DESC_URL;
                    command_list = [];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axios_1.default.get(url, {
                            params: {
                                name: name, provider: provider, version: version
                            }
                        })];
                case 2:
                    result = _a.sent();
                    if (result.data && result.data.Response) {
                        command_2 = result.data.Response.Command || {};
                        command_list = Object.keys(command_2).map(function (key) {
                            return {
                                name: key,
                                desc: command_2[key]
                            };
                        });
                    }
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    logger_1.default.error(e_1.message);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/, command_list];
            }
        });
    });
}
exports.getCommandDetail = getCommandDetail;
function getParsedTemplateObj(templateFile) {
    return __awaiter(this, void 0, void 0, function () {
        var parse, parsedObj;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parse = new parse_1.Parse(templateFile);
                    parsedObj = parse.getOriginalParsedObj();
                    return [4 /*yield*/, parse.getRealVariables(parsedObj)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.getParsedTemplateObj = getParsedTemplateObj;
function getCustomerCommandInfo(parsedTemplateObj) {
    return Object.keys(parsedTemplateObj).filter(function (key) { return key !== 'Global'; });
}
exports.getCustomerCommandInfo = getCustomerCommandInfo;
function createCustomerCommand(templateFile) {
    return __awaiter(this, void 0, void 0, function () {
        var customerCommands, doc, commandListPromise, commondListDetail;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    customerCommands = [];
                    return [4 /*yield*/, getParsedTemplateObj(templateFile)];
                case 1:
                    doc = _a.sent();
                    commandListPromise = getCustomerCommandInfo(doc).map(function (projectName) { return __awaiter(_this, void 0, void 0, function () {
                        var projectDocDetail, Provider, Component, commandList;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    projectDocDetail = doc[projectName];
                                    Provider = projectDocDetail.Provider, Component = projectDocDetail.Component;
                                    return [4 /*yield*/, getCommandDetail(Component, Provider, '')];
                                case 1:
                                    commandList = _a.sent();
                                    return [2 /*return*/, { projectName: projectName, commandList: commandList, projectDocDetail: projectDocDetail }];
                            }
                        });
                    }); });
                    return [4 /*yield*/, Promise.all(commandListPromise)];
                case 2:
                    commondListDetail = _a.sent();
                    commondListDetail.forEach(function (_a) {
                        var projectName = _a.projectName, commandList = _a.commandList, projectDocDetail = _a.projectDocDetail;
                        var customerCommand = new commander_1.Command(projectName);
                        commandList.forEach(function (command) { return __awaiter(_this, void 0, void 0, function () {
                            var commandName, desc, universialCommandInstance;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        commandName = command.name, desc = command.desc;
                                        return [4 /*yield*/, command_1.default(commandName, projectName, desc)];
                                    case 1:
                                        universialCommandInstance = _a.sent();
                                        customerCommand.addCommand(universialCommandInstance);
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        customerCommands.push(customerCommand);
                    });
                    return [2 /*return*/, customerCommands];
            }
        });
    });
}
exports.createCustomerCommand = createCustomerCommand;
function registerCommandChecker(program) {
    program.on('command:*', function (cmds) {
        var commands = program.commands.map(function (command) { return command.name(); });
        if (!commands.includes(cmds[0])) {
            logger_1.default.error("  error: unknown command " + cmds[0]);
            logger_1.default.error();
            program.help();
        }
    });
}
exports.registerCommandChecker = registerCommandChecker;
function registerExitOverride(program) {
    return __awaiter(this, void 0, void 0, function () {
        var checkVersion;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    checkVersion = new check_version_1.CheckVersion();
                    return [4 /*yield*/, checkVersion.init()];
                case 1:
                    _a.sent();
                    program.exitOverride(function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            checkVersion.showMessage();
                            return [2 /*return*/];
                        });
                    }); });
                    return [2 /*return*/];
            }
        });
    });
}
exports.registerExitOverride = registerExitOverride;
function registerCustomerCommand(system_command, templateFile) {
    return __awaiter(this, void 0, void 0, function () {
        var customerCommands;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!templateFile) return [3 /*break*/, 2];
                    return [4 /*yield*/, createCustomerCommand(templateFile)];
                case 1:
                    customerCommands = _a.sent();
                    customerCommands.forEach(function (command) {
                        system_command.addCommand(command);
                    });
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
exports.registerCustomerCommand = registerCustomerCommand;
function regiserUniversalCommand(system_command, templateFile) {
    return __awaiter(this, void 0, void 0, function () {
        var parsedTemplateObj, customerCommands;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!templateFile) return [3 /*break*/, 2];
                    return [4 /*yield*/, getParsedTemplateObj(templateFile)];
                case 1:
                    parsedTemplateObj = _a.sent();
                    customerCommands = getCustomerCommandInfo(parsedTemplateObj);
                    if (process.argv[2] && !customerCommands.includes(process.argv[2])) {
                        system_command.addCommand(command_1.default(process.argv[2]));
                    }
                    else if (process.argv[2] && customerCommands.includes(process.argv[2]) && process.argv[3] && !customerCommands.includes(process.argv[3])) {
                        system_command.addCommand(command_1.default(process.argv[3]));
                    }
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
exports.regiserUniversalCommand = regiserUniversalCommand;
function registerVerbose(program) {
    if (process.argv.includes('--verbose')) {
        process.env.VERBOSE = program.verbose;
    }
}
exports.registerVerbose = registerVerbose;
function recordCommandHistory(argv) {
    var file = storage.getHistoryFile();
    fs.appendFileSync(file, argv.join(',') + os.EOL);
}
exports.recordCommandHistory = recordCommandHistory;
exports.default = registerCommandChecker;
//# sourceMappingURL=command.js.map