"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Parse = void 0;
var yaml = require('js-yaml');
var fs = require('fs');
var path = require('path');
var logger = require("./logger");
var COMMON_VARIABLE_TYPE_REG = new RegExp(/\$\{(.*)\}/, 'i');
var SPECIALL_VARIABLE_TYPE_REG = new RegExp(/(.*)\((.*)\)/, 'i');
var OTHER_BASIC_DATA_TYPE = ['[object Number]', '[object Boolean]'];
var BASIC_DATA_TYPE = ['string', 'number', 'boolean'];
// parse file get variables
// find variables value
var Parse = /** @class */ (function () {
    function Parse(path) {
        this.path = path;
        this.parsedObj = {};
        this.dependenciesMap = {};
        this.globalJsonKeyMap = {};
        this.globalKeyArr = [];
        this.magicVariablesArray = [];
        if (fs.existsSync(path)) {
            try {
                this.init(path);
            }
            catch (ex) {
                throw new Error(ex.message);
            }
        }
    }
    Parse.prototype.getFileObj = function (filePath) {
        var fileObj = {};
        try {
            var extname = path.extname(filePath);
            if (extname.indexOf('.yaml') !== -1 || extname.indexOf('.yml') !== -1) {
                fileObj = yaml.safeLoad(fs.readFileSync(filePath, 'utf8'));
            }
            if (extname.indexOf('.json') !== -1) {
                fileObj = JSON.parse(fs.readFileSync(filePath));
            }
        }
        catch (e) {
            logger.error(e.message);
        }
        return fileObj;
    };
    Parse.prototype.init = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.parsedObj = this.getFileObj(filePath);
                return [2 /*return*/];
            });
        });
    };
    Parse.prototype.getOriginalParsedObj = function () {
        return this.parsedObj;
    };
    Parse.prototype.findVariableValue = function (variableObj) {
        var variableName = variableObj.variableName, type = variableObj.type, funName = variableObj.funName, funVariable = variableObj.funVariable;
        var result = '';
        if (type === 'Literal') {
            return this.globalJsonKeyMparentKeyap[variableName] || '${' + variableName + '}';
        }
        if (type === 'Fun' && funName === 'Env') {
            return process.env[funVariable];
        }
        if (type === 'Fun' && funName === 'File') {
            return this.getFileObj(funVariable);
        }
        return result;
    };
    Parse.prototype.generateMagicVariables = function (value, arr, parentStr) {
        var _this = this;
        if (arr === void 0) { arr = []; }
        if (parentStr === void 0) { parentStr = ''; }
        if (Object.prototype.toString.call(value) === '[object Object]') {
            if (parentStr !== '') {
                parentStr = parentStr + ".";
            }
            Object.keys(value).map(function (key) {
                var showKey = "" + parentStr + key;
                var objValue = value[key];
                arr.push(showKey);
                arr.concat(_this.generateMagicVariables(objValue, arr, "" + showKey));
                try {
                    if (!BASIC_DATA_TYPE.includes(typeof objValue)) {
                        objValue = JSON.stringify(objValue);
                    }
                }
                catch (e) {
                    objValue = objValue.toString();
                }
                _this.globalJsonKeyMap[showKey] = objValue;
            });
        }
        else if (Object.prototype.toString.call(value) === '[object Array]') {
            value.forEach(function (_arrValue, i) {
                var showKey = parentStr + "[" + i + "]";
                var showKeyNe = parentStr + "[" + (i - value.length) + "]";
                arr.push(showKey);
                arr.push(showKeyNe);
                arr.concat(_this.generateMagicVariables(_arrValue, arr, "" + showKey));
                arr.concat(_this.generateMagicVariables(_arrValue, arr, "" + showKeyNe));
                try {
                    if (typeof _arrValue !== 'string') {
                        _arrValue = JSON.stringify(_arrValue);
                    }
                }
                catch (e) {
                    _arrValue = _arrValue.toString();
                }
                _this.globalJsonKeyMap[showKey] = _arrValue;
                _this.globalJsonKeyMap[showKeyNe] = _arrValue;
            });
        }
        else {
            arr = [];
        }
        return arr;
    };
    Parse.prototype.isProjectProperties = function (topKey, parentKey) {
        var projProperties = false;
        if (parentKey === 'Properties' && this.globalJsonKeyMap[topKey + "." + parentKey]) {
            projProperties = true;
        }
        return projProperties;
    };
    Parse.prototype.iteratorToSetValue = function (objValue, topKey, parentKey) {
        var _this = this;
        if (OTHER_BASIC_DATA_TYPE.includes(Object.prototype.toString.call(objValue))) {
            return objValue;
        }
        if (Object.prototype.toString.call(objValue) === '[object String]') {
            // const filePath = !this.isProjectProperties(topKey, parentKey) ? path.resolve(this.path, '..', objValue) : objValue;
            var regResult = objValue.match(COMMON_VARIABLE_TYPE_REG);
            if (regResult) {
                var matchResult = regResult[1]; // get match result like projectName.key.variable
                var variableObj = { variableName: matchResult, type: 'Literal', funName: null, funVariable: '' };
                var funMatchResult = matchResult.match(SPECIALL_VARIABLE_TYPE_REG);
                if (funMatchResult) {
                    // eg Env(SecretId) or ${File(./path)}
                    variableObj.funName = funMatchResult[1];
                    variableObj.funVariable = funMatchResult[2];
                    variableObj.type = 'Fun';
                }
                else {
                    var topKeyDependencisMap = this.dependenciesMap[topKey];
                    if (!topKeyDependencisMap) {
                        topKeyDependencisMap = {};
                    }
                    var dependProjName = matchResult.split('.')[0];
                    topKeyDependencisMap[dependProjName] = 1; // Dependent priority
                    this.dependenciesMap[topKey] = topKeyDependencisMap;
                }
                return this.findVariableValue(variableObj);
            }
            this.dependenciesMap[topKey] = {};
            return objValue;
        }
        if (Object.prototype.toString.call(objValue) === '[object Array]') {
            return objValue.map(function (item) {
                return _this.iteratorToSetValue(item, topKey);
            });
        }
        if (Object.prototype.toString.call(objValue) === '[object Object]') {
            Object.keys(objValue).forEach(function (key) {
                objValue[key] = _this.iteratorToSetValue(objValue[key], topKey, parentKey || key);
            });
            return objValue;
        }
    };
    Parse.prototype.replaceVariable = function (variable) {
        var _this = this;
        Object.keys(variable).forEach(function (key) {
            var objValue = variable[key];
            variable[key] = _this.iteratorToSetValue(objValue, key);
        });
        return variable;
    };
    Parse.prototype.getRealVariables = function (parsedObj) {
        return __awaiter(this, void 0, void 0, function () {
            var replacedObj;
            return __generator(this, function (_a) {
                this.globalKeyArr = this.generateMagicVariables(parsedObj);
                replacedObj = this.replaceVariable(parsedObj);
                return [2 /*return*/, replacedObj];
            });
        });
    };
    return Parse;
}());
exports.Parse = Parse;
//# sourceMappingURL=parse.js.map